// Popis: Knihovna s uzitecnymi funkcemi
// Autor: VasaM
// Licence: CC BY 4.0 CZ



var Pernament = function(modulName, varName, initial, type = 'string') {
	let name = modulName + '_' + varName;
	let data;

	function updateData() {
		data = localStorage.getItem(name);
		
		if (data == null) {
			data = initial;
			localStorage.setItem(name, initial);
		}
		else {	
			switch (type) {
				case 'string':       data = data;                                  break;
				case 'bool':         data = (data == 'true');                      break;
				case 'number':       data = Number(data);                          break;
				case 'stringArray':  data = data.split(',');                       break;   // FIXME nefunuje, pokud pole obsahuje string s ','
				case 'numberArray':  data = data.split(',').map(x => Number(x));   break;
			}
		}
	}

	updateData();
	
	
	return obj = {
		set: function(value) {
			data = value;
			localStorage.setItem(name, value);
			return value;
		},
		get: function() {
			return data;
		},
		update: function() {
			this.set(data);
			updateData();
		},
		delete: function() {
			localStorage.removeItem(name);
		}
	};
}


function deletePernamentModul(modulName) {
	$.each(localStorage, function(key, obj) {
		if (key.startsWith(modulName + '_')) {
			localStorage.removeItem(key);
		}
	})
}




// Prevod znaku na ascii kod
function code(char) {return char.charCodeAt(0);}


// Funkce na pridani prepinace
function addFilter(title, icon, id, position = -1) {
	var filter = '<div class="filter" title="' + title + '">';
	filter    += '  <img class="filtericon" src="' + icon + '">';
	filter    += '  <div class="switch" id="' + id + '"></div>';
	filter    += '</div>';

	if (position == -1) {
		$('#filter-panel').append(filter);
	}
	else {
		$('#filter-panel .filter').eq(position).before(filter);
	}		

	$('#filter-panel').width('auto');
}


// Funkce pro pridani copyrightu pro ikony ze stranek icons8.com
// Je mozne ji volat opakovane, copyright se prida jen jednou
var icons8CopyrightCalled = false;
function icons8Copyright() {
	if (!icons8CopyrightCalled) {
		icons8CopyrightCalled = true;

		addCopyright('Icons8', 'Icons by <a target="_blank" href="https://icons8.com">Icons8</a>');
	}
}


// Funkce pro pridani libovolnych dat do sekce copyrightu
function addCopyright(title, content) {
	ggmregister('onload', function() {
		$('#copyright div.w3-container').append('<h5>' + title + '</h5><p>' + content + '</p>');
	});
}


